Attribute VB_Name = "ModPNG"
Option Explicit

'ModPNG.bas
'mpng.dll 1.10t@PNG`̉摜t@CǂݏpW[
'CopyRight (C) minutes 2002-2003

'GUIDDEF.HQ
Private Type GUID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(7) As Byte
End Type
'OLECTL.HQ
Private Type PICTDESC_BMP
    Size As Long
    Type As Long
    hbmp As Long
    hPal As Long
    Reserved As Long
End Type
Private Declare Function OleCreatePictureIndirect Lib "olepro32.dll" (lpPictDesc As PICTDESC_BMP, riid As GUID, ByVal fOwn As Long, lplpvObj As IPicture) As Long

'==============================================================================
'CreatePictureFromDIBŎg\̂Ɗ֐̒`
Private Type BITMAPINFOHEADER
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type
Private Type RGBQUAD
    rgbBlue As Byte
    rgbGreen As Byte
    rgbRed As Byte
    rgbReserved As Byte
End Type
Private Type BITMAPINFO
    bmiHeader As BITMAPINFOHEADER
    bmiColors(255) As RGBQUAD
End Type


Private Declare Function CreateDIBitmap Lib "gdi32" (ByVal hdc As Long, lpbmih As BITMAPINFOHEADER, ByVal fdwInit As Long, lpbInit As Any, lpbmi As BITMAPINFO, ByVal fuUsage As Long) As Long
Private Const CBM_INIT = &H4
'Private Declare Function GetDC Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function ReleaseDC Lib "user32" (ByVal hwnd As Long, ByVal hdc As Long) As Long


'mpng.dll API
Private Declare Function mLoadPNG Lib "png.dll" (ByVal strfilename As String, hPng As Long, bminfo As BITMAPINFO, Length As Long) As Long
Private Declare Function mEndPNG Lib "png.dll" (hPng As Long) As Long
Private Declare Function mGetPNGData Lib "png.dll" (hPng As Long, buf As Byte) As Long
Private Declare Function mWritePNG Lib "png.dll" (ByVal strfilename As String, lpdat As Byte, bminfo As BITMAPINFO, ByVal Interlace As Long) As Long

Private Declare Function GetDIBits Lib "gdi32" (ByVal aHDC As Long, ByVal hBitmap As Long, ByVal nStartScan As Long, ByVal nNumScans As Long, lpBits As Any, lpBI As BITMAPINFO, ByVal wUsage As Long) As Long

Private Function CreateBitmapPicture(ByVal hbmp As Long, Optional ByVal hPal As Long = 0) As StdPicture
    Dim PicInfo      As PICTDESC_BMP
    Dim sPic         As StdPicture
    Dim IID_IPicture As GUID
    With IID_IPicture
        .Data1 = &H7BF80980
        .Data2 = &HBF32
        .Data3 = &H101A
        .Data4(0) = &H8B
        .Data4(1) = &HBB
        .Data4(2) = &H0
        .Data4(3) = &HAA
        .Data4(4) = &H0
        .Data4(5) = &H30
        .Data4(6) = &HC
        .Data4(7) = &HAB
    End With
    With PicInfo
        .Size = Len(PicInfo)      '\̃TCY
        .Type = vbPicTypeBitmap   'sN`[̎ (rbg}bvΉ)
        .hbmp = hbmp              'rbg}bvւ̃|C^
        .hPal = hPal              'pbgւ̃|C^iȂꍇNULLł悢j
    End With
    If OleCreatePictureIndirect(PicInfo, IID_IPicture, 1, sPic) Then Exit Function
    Set CreateBitmapPicture = sPic
End Function

Private Function CreatePictureFromDIB(dib As Byte, info As BITMAPINFO) As StdPicture
    Dim hdc As Long, hbmp As Long
    hdc = GetDC(0)
    If hdc = 0 Then Exit Function
    hbmp = CreateDIBitmap(hdc, info.bmiHeader, CBM_INIT, dib, info, 0)
    If hbmp = 0 Then Exit Function
    Set CreatePictureFromDIB = CreateBitmapPicture(hbmp)
    ReleaseDC 0, hdc
End Function

Public Function LoadPNG(ByVal strfilename As String) As StdPicture
    Dim hPng   As Long
    Dim Ret    As Long
    Dim bmi    As BITMAPINFO
    Dim Length As Long
    Dim dib()  As Byte
    On Error GoTo Er
    Ret = mLoadPNG(strfilename, hPng, bmi, Length)
    If Ret <> 1 Then
        Debug.Print "Error! code: " & Ret
        Exit Function
    End If

    ReDim dib(Length - 1) As Byte
    Ret = mGetPNGData(hPng, dib(0))
    If Ret <> 1 Then
        Debug.Print "Error! code: " & Ret
        mEndPNG hPng
        Exit Function
    End If
    mEndPNG hPng
    Set LoadPNG = CreatePictureFromDIB(dib(0), bmi)
    Exit Function
Er:
    If Err.Number Then Debug.Print "Error " & Err.Number & " : " & Err.Description
    Set LoadPNG = Nothing
End Function

Public Function SavePNG(im As PictureBox, FileName As String, Optional ByVal Interlace As Boolean = False)
    Dim W As Long
    Dim H As Long
    Dim WLen As Long
    Dim Y As Long
    Dim bminfo As BITMAPINFO
    Dim dib()  As Byte
    Dim tmp() As Byte
    If FileName = "" Then Exit Function
    If im.Picture Is Nothing Then Exit Function
    W = im.Width
    H = im.Height
    ' 
    With bminfo.bmiHeader
        .biSize = Len(bminfo.bmiHeader)
        .biBitCount = 24
        .biClrImportant = 0
        .biClrUsed = 0
        .biCompression = 0
        .biHeight = H
        .biWidth = W
        .biPlanes = 1
        .biSizeImage = 0
        .biXPelsPerMeter = 0
        .biYPelsPerMeter = 0
    End With
    WLen = ((W * 24 \ 8 + 3) And &H7FFFFFFC) - 1
    
    '  
    ReDim dib(WLen, H - 1)
    ReDim tmp(WLen)
    GetDIBits im.hdc, im.Image, 0, H, dib(0, 0), bminfo, 0

    '   -
    For Y = 0 To (H - 1) \ 2
        CopyMemory tmp(0), dib(0, Y), CLng(WLen + 1)
        CopyMemory dib(0, Y), dib(0, H - Y - 1), CLng(WLen + 1)
        CopyMemory dib(0, H - Y - 1), tmp(0), CLng(WLen + 1)
    Next
    
    '   PNG
    mWritePNG FileName, dib(0, 0), bminfo, -CLng(Interlace)
End Function








