Attribute VB_Name = "Picture"
Public Type UndoRedo
  cName As String
  picIndex As Long
  cW As Long
  cH As Long
  Exist As Boolean
  bType As Long
End Type

Public PictureWidth As Long
Public PictureHeight As Long
Public PictureBits As Long

' Undo, Redo
Public CurrentPicture As Long
Public EndPicture As Long

Public ChangeP() As UndoRedo
Public uList() As Long
Public bList() As Long



Public Sub DeleteIndex(Arr() As Long, I As Long)
  L = UBound(Arr)
  If L = 0 Then Exit Sub
  If I = L Then ReDim Preserve Arr(L - 1): Exit Sub
  For n = I + 1 To L
    Arr(n - 1) = Arr(n)
  Next
  ReDim Preserve Arr(L - 1)
End Sub


Public Sub InitUndoRedo()
On Error GoTo Err:
  L = UBound(uList)
  For n = 0 To L
    Set frmMain.undoPC(uList(n)).Picture = Nothing
  Next
  ReDim uList(0)
  
  FP = FindFreeUR
  If FP = -1 Then
    '    ,  
    L = UBound(ChangeP) + 1
    ReDim Preserve ChangeP(L)
    Load frmMain.undoPC(L)
  Else
    '   ,   
    L = FP
  End If
  uList(0) = L
  '   
  Set frmMain.undoPC(L).Picture = frmMain.im.Image
  ChangeP(L).cName = "OPEN"
  ChangeP(L).cW = frmMain.im.Width
  ChangeP(L).cH = frmMain.im.Height
  ChangeP(L).Exist = True
  GoTo 2
Err:
  ReDim uList(0)
  ReDim ChangeP(0)
  uList(0) = 0
  ChangeP(0).cName = "OPEN"
  Set frmMain.undoPC(0).Picture = frmMain.im.Picture
  ChangeP(0).cW = frmMain.im.Width
  ChangeP(0).cH = frmMain.im.Height
  ChangeP(0).Exist = True
  For n = 1 To frmMain.List1(0).ListCount - 1
    Set frmMain.undoPC(n).Picture = Nothing
  Next
2 CurrentPicture = 0
  EndPicture = 0
  frmMain.List1(0).Clear
  frmMain.List1(0).AddItem "Open"
  frmMain.List1(0).ListIndex = 0
End Sub



'''  ,  
Private Function FindFreeUR()
  Dim n As Long
  For n = 0 To UBound(ChangeP)
    If ChangeP(n).Exist = False Then
      FindFreeUR = n
      Exit Function
    End If
  Next
  FindFreeUR = -1
End Function
Function GetbListBound()
On Error GoTo 2
  I = UBound(bList)
  GetbListBound = I
  Exit Function
2
GetbListBound = -1
End Function

Public Sub AddToBuffer(pic As PictureBox)
Dim Sum As Long, I As Long
  
  B = 0
  '   
  Sum = 1
  For n = 0 To UBound(ChangeP)
    If ChangeP(n).Exist = True Then B = B + 1: Sum = Sum + ChangeP(n).cW * ChangeP(n).cH * 4
  Next
  If Sum >= AllocatedMem Then
    MsgBox "   .    .", vbCritical, ""
    Exit Sub
  End If

  
  FP = FindFreeUR
  If FP = -1 Then
    '    ,  
    L = UBound(ChangeP) + 1
    ReDim Preserve ChangeP(L)
    Load frmMain.undoPC(L)
  Else
    '   ,   
    L = FP
  End If
  
  I = GetbListBound
  If I = -1 Then
    ReDim bList(0)
    I = 0
  Else
    ReDim Preserve bList(I + 1)
    I = I + 1
  End If
  bList(I) = L

  '   

  Set frmMain.undoPC(L).Picture = pic.Image
  ChangeP(L).cName = "buffer"
  ChangeP(L).cW = pic.Width
  ChangeP(L).cH = pic.Height
  ChangeP(L).Exist = True
  ChangeP(L).bType = 1
  
  '     
  frmMain.List1(1).Clear
  For n = 0 To UBound(bList)
      frmMain.List1(1).AddItem "#" & n + 1
  Next

End Sub


Public Sub SetNextPicture(cName As String)
Dim Sum As Long
  ' ,    
  NewDoc = 1
  
  '   
  Sum = 1
  For n = 0 To UBound(ChangeP)
    If ChangeP(n).Exist = True Then Sum = Sum + ChangeP(n).cW * ChangeP(n).cH * 4
  Next
  If Sum >= AllocatedMem Then
    '''  
    '   
    Set frmMain.undoPC(uList(0)).Picture = Nothing
    ChangeP(uList(0)).Exist = False
    '   
    If UBound(uList) <> 0 Then
      For n = 0 To UBound(uList) - 1
        uList(n) = uList(n + 1)
      Next
      ReDim Preserve uList(UBound(uList) - 1)
      CurrentPicture = CurrentPicture - 1
    End If
  End If
  
  
  CurrentPicture = CurrentPicture + 1
  EndPicture = CurrentPicture

  
  '     CurrentPicture
  If CurrentPicture < UBound(ChangeP) Then
    For n = CurrentPicture + 1 To UBound(ChangeP)
      If ChangeP(n).bType = 0 Then ChangeP(n).Exist = False
    Next
  End If
  ReDim Preserve uList(CurrentPicture)
  
  FP = FindFreeUR
  If FP = -1 Then
    '    ,  
    L = UBound(ChangeP) + 1
    ReDim Preserve ChangeP(L)
    Load frmMain.undoPC(L)
  Else
    '   ,   
    L = FP
    
    '    
    For n = 0 To UBound(ChangeP)
      If ChangeP(n).Exist = False Then
        Set frmMain.undoPC(n).Picture = Nothing
      End If
    Next
  End If
  
  uList(CurrentPicture) = L


  '   
  Set frmMain.undoPC(L).Picture = frmMain.im.Image
  ChangeP(L).cName = cName
  ChangeP(L).cW = frmMain.im.Width
  ChangeP(L).cH = frmMain.im.Height
  ChangeP(L).Exist = True
  ChangeP(L).bType = 0
  
  '   
  initUndoMenu
  
  '     
  frmMain.List1(0).Clear
  For n = 0 To UBound(uList)
      frmMain.List1(0).AddItem ChangeP(uList(n)).cName
  Next
  frmMain.List1(0).ListIndex = CurrentPicture
End Sub

Public Sub GetURPicture(I)
On Error Resume Next
  CurrentPicture = I
  L = uList(I)
  
  Set frmMain.im.Picture = frmMain.undoPC(L).Image
  
  initUndoMenu
End Sub

Public Sub GetUndoPicture()
  CurrentPicture = CurrentPicture - 1
  
  If CurrentPicture < 0 Then
    CurrentPicture = 0
  End If
  
  L = uList(CurrentPicture)
  
  Set frmMain.im.Picture = frmMain.undoPC(L).Image
  
  initUndoMenu
  
  frmMain.List1(0).ListIndex = CurrentPicture
End Sub

Public Sub GetRedoPicture()
  ' -  
  Pct = frmMain.undoPC.Count
  
  CurrentPicture = CurrentPicture + 1
  
  If CurrentPicture > UBound(uList) Then
    CurrentPicture = UBound(uList)
  End If
  
  L = uList(CurrentPicture)

  
  Set frmMain.im.Picture = frmMain.undoPC(L).Image
  
  initUndoMenu
  
  frmMain.List1(0).ListIndex = CurrentPicture
End Sub

Sub initUndoMenu()
  ' -  
  Pct = frmMain.undoPC.Count
  If CurrentPicture = 0 Then
    frmMain.mnuUNDO.Enabled = False
    If EndPicture > 0 Then frmMain.mnuREDO.Enabled = True
  Else
    If CurrentPicture = EndPicture Then
      If CurrentPicture > 0 Then frmMain.mnuUNDO.Enabled = True
      frmMain.mnuREDO.Enabled = False
    Else
      frmMain.mnuUNDO.Enabled = True
      frmMain.mnuREDO.Enabled = True
    End If
  End If
End Sub


