Attribute VB_Name = "Settings"
Public Type POINTAPI
        X As Long
        Y As Long
End Type

'Public Declare Function SetCursorPos& Lib "user32" (ByVal X As Long, ByVal Y As Long)
Public Declare Function GetCursorPos& Lib "user32" (lpPoint As POINTAPI)

'Public Declare Function UgN Lib "pgsmt.dll" Alias "UgN@32" (ByVal a As Double, ByVal B As Double, ByVal X As Double, ByVal Y As Double) As Double
'Public Declare Function HSize Lib "pgsmt.dll" Alias "HSize@32" (ByVal a As Double, ByVal B As Double, ByVal X As Double, ByVal Y As Double) As Double
'Public Declare Function GradLeaner Lib "pgsmt.dll" Alias "GradLeaner@32" (ByVal Val1 As Double, ByVal Val2 As Double, ByVal MaxWidth As Double, ByVal Value As Double) As Double
'Public Declare Function GetRNDResault Lib "pgsmt.dll" Alias "GetRNDResault@16" (ByVal CurVal As Double, ByVal fromVal As Double) As Byte
'Public Declare Function mSIN Lib "pgsmt.dll" Alias "mSIN@8" (ByVal F As Double) As Double
'Public Declare Function mCOS Lib "pgsmt.dll" Alias "mCOS@8" (ByVal F As Double) As Double
'Public Declare Function sqrDT Lib "pgsmt.dll" Alias "sqrDT@32" (W As Double, H As Double, X As Double, Y As Double, I1 As Double, I2 As Double, I3 As Double, I4 As Double) As Double
Public Declare Function TerminateThread Lib "kernel32" (ByVal hThread As Long, ByVal dwExitCode As Long) As Long

Public Declare Function LockWindowUpdate Lib "user32" (ByVal hwndLock As Long) As Long


Public SQRConts() As Long
Public SQR2() As Long
Public Plus1(4096) As Integer
Public Minus1(4096) As Integer

Public selX As Long
Public selY As Long
Public selW As Long
Public selH As Long
Public selIs As Long
Public selMove As Long
Public OselX As Long, OselY As Long, OselW As Long, OselH As Long, OselIs As Long, OselMove As Long
Public selName As String

'    
Public DocName As String '  
Public DocPath As String '   
Public DocExt As String  '  
Public NewDoc As Long    '   

Public LastPath As String
Public DegubMode As Long
Public TextString As String


Public View1 As Long
Public View2 As Long
Public View3 As Long
Public View4 As Long
Public View5 As Long

Public ElasticSize As Long
Public Transparency As Long

Public PenSize As Long
Public SpaySize As Long
Public LineWidth As Long
Public FigureSold As Long

Public Zoom As Long
Public ShowGrid As Long
Public LastZoom As Long

'  
Public DrawType As Long


' == 
Public AutoSave As Long
Public AutoSaveTime As Long

' == 
Public AllocatedMem As Long
Public QualityPreView As Long
Public HiQBrush As Long
Public ShortStep As Long

Public TopColor As Long
Public BotColor As Long


Public LastSaveTime As Double

' == ,   
Public SaveAspect As Long
Public DoNotStretch As Long

Public Sub Main()
  '''   
  LoadSettings
  
  '''     
  LockWindowUpdate frmMain.hwnd
    frmMain.IntiPanelBox
    frmMain.Show
  LockWindowUpdate 0
  
  '''     
  DoEvents
    frmMain.IntiInterface
    SetColorPal
    InitUndoRedo
    frmMain.IntiAfter
    frmMain.SetPreview
End Sub


Sub SaveLocalSettings()
  SaveSetting "PaintPro", "global", "wind", frmMain.left & "," & frmMain.top & "," & frmMain.Width & "," & frmMain.Height
  SaveSetting "PaintPro", "global", "windstate", frmMain.WindowState
  SaveSetting "PaintPro", "global", "workspace", frmMain.im.Width & "," & frmMain.im.Height
  SaveSetting "PaintPro", "global", "general", AutoSave & "," & AutoSaveTime
  SaveSetting "PaintPro", "global", "path", LastPath
  SaveSetting "PaintPro", "global", "interface", View1 & "," & View2 & "," & View3 & "," & View4 & "," & View5
  SaveSetting "PaintPro", "global", "performance", QualityPreView & "," & AllocatedMem & "," & HiQBrush & "," & ShortStep
End Sub

Sub LoadSettings()
  Dim DD As String
  '  ,   
  On Error Resume Next
  Dim S As String
  Dim SD() As String

  
  '  
  S = GetSetting("PaintPro", "global", "wind", frmMain.left & "," & frmMain.top & "," & frmMain.Width & "," & frmMain.Height)
  SD = Split(S, ",")
  st = GetSetting("PaintPro", "global", "windstate", frmMain.WindowState)
  If SD(0) < 0 Or SD(0) > Screen.Width + 10 * Screen.TwipsPerPixelX Then SD(0) = 0
  If SD(1) < 0 Or SD(1) > Screen.Height + 10 * Screen.TwipsPerPixelY Then SD(1) = 0
  If st = 1 Then st = 0: SD(2) = 0: SD(3) = 0
  If st = 0 Then
    frmMain.left = Val(SD(0))
    frmMain.top = Val(SD(1))
    If Val(SD(2)) > 10 * Screen.TwipsPerPixelX And Val(SD(2)) < Screen.Width + 10 * Screen.TwipsPerPixelX Then frmMain.Width = Val(SD(2))
    If Val(SD(3)) > 10 * Screen.TwipsPerPixelY And Val(SD(3)) < Screen.Height + 10 * Screen.TwipsPerPixelY Then frmMain.Height = Val(SD(3))
  End If
  frmMain.WindowState = Val(st)
  
'''    
  If Dir$(App.Path & "\tmp.bmp") <> "" Then
    I = MsgBox("  ?", vbQuestion + vbYesNo, "")
    If I = 6 Then
      frmMain.im.Picture = LoadPicture(App.Path & "\tmp.bmp")
      GoTo endld
    Else
      KillBackUp
    End If
  End If
'''   Command
  DD = Replace$(Command$, Chr$(34), "")
  If DD <> "" Then
    I = frmMain.OpenDocument(frmMain.im, DD, 0)
    LastPath = dlgPathFolder(DD)
    DocPath = DD
    DocExt = dlgExtension(DD)
    DocName = dlgFileName(DD)
  Else
    '''  
    LastPath = GetSetting("PaintPro", "global", "path", App.Path)
    DocName = ""
  End If
'''   
  If DD = "" Or I = 1 Then
    '  
    S = GetSetting("PaintPro", "global", "workspace", frmMain.im.Width & "," & frmMain.im.Height)
    SD = Split(S, ",")
    If Val(SD(0)) < 1 Then SD(0) = 1
    If Val(SD(1)) < 1 Then SD(1) = 1
    If Val(SD(0)) > 2048 Then SD(0) = 2048
    If Val(SD(1)) > 2048 Then SD(1) = 2048
    DoEvents
    '  
    frmMain.im.Picture = LoadPicture
    frmMain.im.Width = Val(SD(0))
    frmMain.im.Height = Val(SD(1))
    frmMain.im.Picture = frmMain.im.Image
  End If
endld:

  '''  
  S = GetSetting("PaintPro", "global", "general", "1,120")
  SD = Split(S, ",")
  AutoSave = Val(SD(0))
  AutoSaveTime = Val(SD(1))
  

  
  ''' 
  S = GetSetting("PaintPro", "global", "interface", "1,1,1,1,0")
  SD = Split(S, ",")
  View1 = Val(SD(0))
  View2 = Val(SD(1))
  View3 = Val(SD(2))
  View4 = Val(SD(3))
  View5 = Val(SD(4))
  
  ''' 
  S = GetSetting("PaintPro", "global", "performance", "1,26214400,0,0")
  SD = Split(S, ",")
  QualityPreView = Val(SD(0))
  AllocatedMem = Val(SD(1))
  HiQBrush = Val(SD(2))
  ShortStep = Val(SD(3))

  BotColor = 16777215
  ElasticSize = 4
  Zoom = 1
  
  PenSize = 6
  
  SpaySize = 6
  LineWidth = 1
  LastZoom = 4
  LastSaveTime = Timer
  SaveAspect = 1
  DrawType = vbSrcCopy
  
  



'''  . 
  Dim n As Long
  ReDim SQRConts(720000)
  ReDim SQR2(-9999 To 9999)
  DoEvents
  '   
  For n = 0 To 720000
    SQRConts(n) = Sqr(n)
  Next
  DoEvents
  '    
  For n = -9999 To 9999
    SQR2(n) = n ^ 2
  Next
  DoEvents
  '   +1  -1
  For n = 0 To 4096
    Plus1(n) = n + 1
    Minus1(n) = n - 1
  Next
End Sub

Private Sub SetColorToPal(I, R, G, B)
  frmMain.sCol(I).BackColor = RGB(R / 4, G / 4, B / 4)
  frmMain.sCol(I + 1).BackColor = RGB(R / 2, G / 2, B / 2)
  frmMain.sCol(I + 2).BackColor = RGB(R, G, B)
End Sub
Private Sub SetColorPal()
  frmMain.sCol(0).BackColor = RGB(0, 0, 0)
  frmMain.sCol(1).BackColor = RGB(128, 128, 128)
  frmMain.sCol(2).BackColor = RGB(255, 255, 255)
  frmMain.sCol(3).BackColor = RGB(64, 64, 64)
  frmMain.sCol(4).BackColor = RGB(128, 128, 128)
  frmMain.sCol(5).BackColor = RGB(192, 192, 192)
  SetColorToPal 6, 255, 0, 0
  SetColorToPal 9, 255, 128, 0
  SetColorToPal 12, 255, 255, 0
  SetColorToPal 15, 0, 255, 0
  SetColorToPal 18, 0, 255, 255
  SetColorToPal 21, 0, 0, 255
  SetColorToPal 24, 255, 0, 255
  
  SetColorToPal 27, 255, 128, 0
  SetColorToPal 30, 128, 255, 0
  SetColorToPal 33, 0, 255, 128
  SetColorToPal 36, 0, 128, 255
  SetColorToPal 39, 128, 0, 255
End Sub





Public Function DifferenceSel()
  If OselX <> selX Then DifferenceSel = 1: Exit Function
  If OselY <> selY Then DifferenceSel = 1: Exit Function
  If OselW <> selW Then DifferenceSel = 1: Exit Function
  If OselH <> selH Then DifferenceSel = 1: Exit Function
End Function
Public Sub SetOldSel()
  OselX = selX
  OselY = selY
  OselW = selW
  OselH = selH
End Sub

'Public Sub 'SendData(Data)
'On Error GoTo Err:
'If DegubMode = 1 Then
'  frmMain.S1.'SendData Data
'End If
'Err:
'End Sub






Sub KillBackUp()
On Error GoTo 2
  Kill App.Path & "\tmp.bmp"
2
End Sub

Function UgN(X, Y, A, B)
Dim Pi As Single, Ug As Single
Pi = 3.14159265358979
If X = A And Y > B Then Ug = Pi
If X = A And Y < B Then Ug = 0
If X > A And Y = B Then Ug = 1.5 * Pi
If X < A And Y = B Then Ug = Pi * 0.5
If X = A And Y = B Then Ug = -Pi * 0.5
If X > A And Y > B Then Ug = 1.5 * Pi - Atn((Y - B) / (X - A))
If X > A And Y < B Then Ug = Atn((B - Y) / (X - A)) - Pi * 0.5
If X < A And Y < B Then Ug = Pi * 0.5 - Atn((B - Y) / (A - X))
If X < A And Y > B Then Ug = Pi * 0.5 + Atn((Y - B) / (A - X))
UgN = Ug
End Function


' 
Public Sub MergeSort(ByRef Arr() As Long, ByVal n As Long)
    Dim C As Boolean
    Dim I As Long
    Dim I1 As Long
    Dim I2 As Long
    Dim N1 As Long
    Dim N2 As Long
    Dim J As Long
    Dim k As Long
    Dim tmp As Long
    Dim BArr() As Double
    Dim MergeLen As Long

    ReDim BArr(0# To n - 1#)
    MergeLen = 1#
    C = True
    Do While MergeLen < n
        If C Then
            I = 0#
            Do While I + MergeLen <= n
                I1 = I + 1#
                I2 = I + MergeLen + 1#
                N1 = I + MergeLen
                N2 = I + 2# * MergeLen
                If N2 > n Then
                    N2 = n
                End If
                Do While I1 <= N1 Or I2 <= N2
                    If I1 > N1 Then
                        Do While I2 <= N2
                            I = I + 1#
                            BArr(I - 1#) = Arr(I2 - 1#)
                            I2 = I2 + 1#
                        Loop
                    Else
                        If I2 > N2 Then
                            Do While I1 <= N1
                                I = I + 1#
                                BArr(I - 1#) = Arr(I1 - 1#)
                                I1 = I1 + 1#
                            Loop
                        Else
                            If Arr(I1 - 1#) > Arr(I2 - 1#) Then
                                I = I + 1#
                                BArr(I - 1#) = Arr(I2 - 1#)
                                I2 = I2 + 1#
                            Else
                                I = I + 1#
                                BArr(I - 1#) = Arr(I1 - 1#)
                                I1 = I1 + 1#
                            End If
                        End If
                    End If
                Loop
            Loop
            I = I + 1#
            Do While I <= n
                BArr(I - 1#) = Arr(I - 1#)
                I = I + 1#
            Loop
        Else
            I = 0#
            Do While I + MergeLen <= n
                I1 = I + 1#
                I2 = I + MergeLen + 1#
                N1 = I + MergeLen
                N2 = I + 2# * MergeLen
                If N2 > n Then
                    N2 = n
                End If
                Do While I1 <= N1 Or I2 <= N2
                    If I1 > N1 Then
                        Do While I2 <= N2
                            I = I + 1#
                            Arr(I - 1#) = BArr(I2 - 1#)
                            I2 = I2 + 1#
                        Loop
                    Else
                        If I2 > N2 Then
                            Do While I1 <= N1
                                I = I + 1#
                                Arr(I - 1#) = BArr(I1 - 1#)
                                I1 = I1 + 1#
                            Loop
                        Else
                            If BArr(I1 - 1#) > BArr(I2 - 1#) Then
                                I = I + 1#
                                Arr(I - 1#) = BArr(I2 - 1#)
                                I2 = I2 + 1#
                            Else
                                I = I + 1#
                                Arr(I - 1#) = BArr(I1 - 1#)
                                I1 = I1 + 1#
                            End If
                        End If
                    End If
                Loop
            Loop
            I = I + 1#
            Do While I <= n
                Arr(I - 1#) = BArr(I - 1#)
                I = I + 1#
            Loop
        End If
        MergeLen = 2# * MergeLen
        C = Not C
    Loop
    If Not C Then
        I = 1#
        Do
            Arr(I - 1#) = BArr(I - 1#)
            I = I + 1#
        Loop Until Not I <= n
    End If
End Sub
